property pointerStyle, customImage, customMask, currentPointer, Rpointerstyle, RCustomImage, RCustomMask, useCustom, useCustomR, changeBegin, changeEnd

on beginSprite me
  if changeBegin then
    ChangeCursor(me)
  end if
end

on endSprite me
  if changeEnd then
    restoreCursor(me)
  end if
end

on ChangeCursor me
  set currentPointer to translate_cursor(me, pointerStyle, customImage, customMask, useCustom)
  cursor(currentPointer)
end

on restoreCursor me
  set currentPointer to translate_cursor(me, Rpointerstyle, RCustomImage, RCustomMask, useCustomR)
  cursor(currentPointer)
end

on translate_cursor me, setting, image, mask, Custom
  if Custom then
    set val to [member image, member mask]
    return val
  end if
  return setting
end

on getPropertyDescriptionList
  set p_list to [#changeBegin: [#comment: "Change Pointer on BeginSprite:", #format: #boolean, #default: 0], #changeEnd: [#comment: "Restore Pointer on EndSprite:", #format: #boolean, #default: 0], #pointerStyle: [#comment: "Pointer Image:", #format: #cursor, #default: 1], #useCustom: [#comment: "Use Custom Pointer Image:", #format: #boolean, #default: 0], #customImage: [#comment: "Custom Image:", #format: #bitmap, #default: member 1], #customMask: [#comment: "Custom Mask:", #format: #bitmap, #default: member 1], #Rpointerstyle: [#comment: "Restored Pointer Image:", #format: #cursor, #default: 1], #useCustomR: [#comment: "Restore Custom Pointer Image:", #format: #boolean, #default: 0], #RCustomImage: [#comment: "Restored Custom Image:", #format: #bitmap, #default: member 1], #RCustomMask: [#comment: "Restored Custom Mask:", #format: #bitmap, #default: member 1]]
  return p_list
end

on getBehaviorDescription
  return "Changes the pointer image to one of the pointers included with Director, or to a  1-bit bitmapped castmember. Attach the behavior to a sprite or place it in the script channel." & RETURN & "PARAMETERS:" & RETURN & "• Change on BeginSprite - Turn this option on to change the pointer in the frame where the sprite begins." & RETURN & "• Change on EndSprite - Turn this option on to restore the pointer in the frame after the sprite ends." & RETURN & "• Pointer - Choose one of Director's included pointers." & RETURN & "• Use Custom - Turn this option on to use a cast member for a pointer instead of one of Director's included pointers." & RETURN & "• Custom Image  - ( optional ) Choose which cast member to use as a pointer image. This setting is ignored if Use Custom isn't on." & RETURN & "• Custom Mask - ( optional ) Choose a cast member to use as a mask image." & RETURN & "• Restored Pointer - Choose one of Director's included pointers to be displayed when the sprite ends." & RETURN & "• Restore Custom - Turn this option on to display a cast member when the sprite ends." & RETURN & "• Restored Custom Image  - ( optional ) Choose a cast member to display as the pointer image when the sprite ends." & RETURN & "• Restored Custom Mask - ( optional ) Choose a cast member to use as a mask image when the sprite ends.  " & RETURN & "MESSAGES:" & RETURN & "• ChangeCursor - Changes the pointer to the specified image." & RETURN & "• RestoreCursor - Restores the original pointer image."
end
